package com.willshex.android.fingerspell;

import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceActivity;
import android.widget.SeekBar;
import android.widget.SeekBar.OnSeekBarChangeListener;

import com.willshex.android.fingerspell.utilities.SettingsUtility;

/**
 * 
 * @author billy1380
 */
public class FingerspellSettings extends PreferenceActivity implements
		SharedPreferences.OnSharedPreferenceChangeListener {

	public static final String SHARED_PREFERENCES_NAME = "AndroidFingerSpellSettings";

	private boolean attachedSpeedHandler = false;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		getPreferenceManager()
				.setSharedPreferencesName(SHARED_PREFERENCES_NAME);
		addPreferencesFromResource(R.xml.androidfingerspell_settings);

		SharedPreferences sharedPreferences = getPreferenceManager()
				.getSharedPreferences();
		sharedPreferences.registerOnSharedPreferenceChangeListener(this);

		return;
	}

	@Override
	public void onWindowFocusChanged(boolean hasFocus) {
		super.onWindowFocusChanged(hasFocus);

		if (!attachedSpeedHandler) {
			SeekBar speed = (SeekBar) findViewById(R.id.SeekBar01);

			speed.setProgress(SettingsUtility.getSpeed(this));

			speed.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {

				private final static int MIN_WAIT = 150;

				@Override
				public void onStopTrackingTouch(SeekBar seekBar) {
					return;
				}

				@Override
				public void onStartTrackingTouch(SeekBar seekBar) {
					return;
				}

				@Override
				public void onProgressChanged(SeekBar seekBar, int progress,
						boolean fromUser) {
					if (fromUser) {
						SettingsUtility.setSpeed(progress < MIN_WAIT ? MIN_WAIT
								: progress, FingerspellSettings.this);

						if (progress < MIN_WAIT) {
							seekBar.setProgress(MIN_WAIT);
						}
					}
					return;
				}

			});

			attachedSpeedHandler = true;
		}

		return;
	}

	@Override
	protected void onDestroy() {
		getPreferenceManager().getSharedPreferences()
				.unregisterOnSharedPreferenceChangeListener(this);
		super.onDestroy();
	}

	@Override
	public void onSharedPreferenceChanged(SharedPreferences sharedPreferences,
			String key) {

		return;
	}

}
