package com.willshex.android.fingerspell;

import java.util.regex.Pattern;

import org.bithir.fingerspell.TextWordEngine;
import org.bithir.fingerspell.WordEngine;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;

import com.willshex.android.fingerspell.utilities.SettingsUtility;
import com.willshex.android.fingerspell.views.SvgView;
import com.willshex.android.fingerspell.views.SvgView.Mode;

public class TeachMe extends Activity {

	private SvgView svgView = null;
	private int position = 0;
	private String word;
	private WordEngine wordEngine;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.teach_me);

		wordEngine = SettingsUtility.getWordEngine(this);
		
		((Button) findViewById(R.id.ButtonPrevious))
				.setOnClickListener(new OnClickListener() {

					@Override
					public void onClick(View v) {
						moveToPrevious();
						svgView.setLetter(new String(
								new char[] { TextWordEngine.Alphabet
										.charAt(position) }));
						svgView.invalidate();

						return;
					}
				});

		((Button) findViewById(R.id.ButtonUseIt))
				.setOnClickListener(new OnClickListener() {

					@Override
					public void onClick(View v) {
						getNewSuitableWord();
						Toast
								.makeText(
										getApplicationContext(),
										"The example word is: "
												+ word.toUpperCase(), 3).show();
						return;
					}
				});

		((Button) findViewById(R.id.ButtonNext))
				.setOnClickListener(new OnClickListener() {

					@Override
					public void onClick(View v) {
						moveToNext();
						svgView.setLetter(new String(
								new char[] { TextWordEngine.Alphabet
										.charAt(position) }));
						svgView.invalidate();

						return;
					}
				});

		svgView = (SvgView) findViewById(R.id.TeachSvgView);
		svgView.setMode(Mode.Teach);
		svgView.setLetter(new String(new char[] { TextWordEngine.Alphabet
				.charAt(position) }));
		svgView.invalidate();

		return;
	}

	private void getNewSuitableWord() {
		word = wordEngine.getWordStartingWith(TextWordEngine.Alphabet
				.charAt(position));

		Pattern alphabetic = Pattern.compile("[a-zA-Z]*");

		while (!alphabetic.matcher(word).matches()) {
			word = wordEngine.getWordStartingWith(TextWordEngine.Alphabet
					.charAt(position));
		}

		return;
	}

	private void moveToPrevious() {
		if (position == 0) {
			position = TextWordEngine.Alphabet.length() - 1;
		} else {
			--position;
		}
		return;
	}

	private void moveToNext() {
		if (position == TextWordEngine.Alphabet.length() - 1) {
			position = 0;
		} else {
			position++;
		}
		return;
	}
}
