package com.willshex.android.fingerspell;

import java.util.regex.Pattern;

import org.bithir.fingerspell.WordEngine;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;

import com.willshex.android.fingerspell.utilities.SettingsUtility;
import com.willshex.android.fingerspell.views.SvgView;
import com.willshex.android.fingerspell.views.SvgView.Mode;

public class TestMe extends Activity {

	private SvgView svgView = null;
	private WordEngine wordEngine;
	private String word = null;
	private int progress = 0;
	private Handler timer = new Handler();

	private Runnable nextLetterTask = new Runnable() {

		@Override
		public void run() {
			if (progress < word.length()) {
				svgView.setLetter(new Character(word.charAt(progress++))
						.toString());
				svgView.invalidate();
				timer.postDelayed(nextLetterTask, SettingsUtility
						.getSpeed(TestMe.this));
			} else {
				timer.removeCallbacks(nextLetterTask);
			}
		}
	};

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.test_me);

		wordEngine = SettingsUtility.getWordEngine(this);
		
		((Button) findViewById(R.id.ButtonReveal))
				.setOnClickListener(new OnClickListener() {

					@Override
					public void onClick(View v) {
						Toast
								.makeText(
										getApplicationContext(),
										"The current word is: "
												+ word.toUpperCase(), 3).show();

						return;
					}
				});

		((Button) findViewById(R.id.ButtonNext))
				.setOnClickListener(new OnClickListener() {

					@Override
					public void onClick(View v) {
						getNewSuitableWord();
						progress = 0;
						timer.removeCallbacks(nextLetterTask);
						timer.postDelayed(nextLetterTask, SettingsUtility
								.getSpeed(TestMe.this));

						return;
					}
				});

		((Button) findViewById(R.id.ButtonRepeat))
				.setOnClickListener(new OnClickListener() {

					@Override
					public void onClick(View v) {
						progress = 0;
						timer.removeCallbacks(nextLetterTask);
						timer.postDelayed(nextLetterTask, SettingsUtility
								.getSpeed(TestMe.this));

						return;
					}
				});

		svgView = (SvgView) findViewById(R.id.TestSvgView);
		svgView.setMode(Mode.Test);
		getNewSuitableWord();
		timer.postDelayed(nextLetterTask, SettingsUtility
				.getSpeed(this));

		return;
	}

	private void getNewSuitableWord() {
		word = wordEngine.getNextRandomWord();

		Pattern alphabetic = Pattern.compile("[a-zA-Z]*");

		while (!alphabetic.matcher(word).matches()) {
			word = wordEngine.getNextRandomWord();
		}

		return;
	}
}
